<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css" />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  
    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
    <link rel="stylesheet" href="style.css">
    <title>Login Signup Form</title>
</head>
<body>
    <div class="login-page">
        <div class="form">
          <form class="register-form">
            <input id="inp-signup-username" type="text" placeholder="name"/>
            <input id="inp-signup-password" type="password" placeholder="password"/>
            <!-- <input type="text" placeholder="email address"/> -->
            <button id="btn-signup">create</button>
            <p class="message">Already registered? <a href="#">Sign In</a></p>
          </form>
          <div class="login-form">
            <input id="inp-login-username" type="text" placeholder="username"/>
            <input id="inp-login-password" type="password" placeholder="password"/>
            <button id="btn-login">login</button>
            <p class="message">Not registered? <a>Create an account</a></p>
          </div>
        </div>
      </div>
</body>
<script>
    "use strict"
    $(document).ready(function(){
    //Vùng 1: định nghĩa global variable (biến toàn cục)

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $('.message a').click(function(){
        $('form').animate({height: "toggle", opacity: "toggle"}, "slow");
    });
    $('#btn-login').on('click', function() {
        onBtnLoginClick();
    });
    $("#btn-signup").on("click", function() {
        onBtnSignUpClick();
    })
   
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onBtnLoginClick() {
        //B1  Thu Thập Dữ Liệu
        var vUserData = readDataFromFormLogin();
        //B2  Kiểm tra dữ liệu
        var vIsValid = validateData(vUserData);
        if(vIsValid) {
          //B3 call APi Đăng Nhập
          callAjaxApiLogin(vUserData);
        }
    }
    function onBtnSignUpClick() {
        //B1  Thu Thập Dữ Liệu
        var vUserData = readDataFromFormSignup();
        //B2  Kiểm tra dữ liệu
        var vIsValid = validateData(vUserData);
        if(vIsValid) {
          //B3 call APi Đăng Nhập
          callAjaxApiSignup(vUserData);
        }
    }
    
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function readDataFromFormLogin() {
        var vUserData = {
            username: $.trim($("#inp-login-username").val()),
            password: $.trim($("#inp-login-password").val())
        }
        return vUserData;
    };
    function readDataFromFormSignup() {
        var vUserData = {
            username: $.trim($("#inp-signup-username").val()),
            password: $.trim($("#inp-signup-password").val())
        }
        return vUserData;
    };
    // B2 Kiem Tra Du Lieu 
    function validateData(paramData){
        if(paramData.username == ""){
            alert("Chưa Nhập username")
            return false;
        }
        if(paramData.password == ""){
            alert("Chưa Nhập password")
            return false;
        }
        return true;
    }
    //call api dang nhap tai khoan
    function callAjaxApiLogin(paramUserData){
        "use strict";
        $.ajax({
            url: "http://localhost:8080/login",
            type: "POST",
            async: false,
            data: JSON.stringify(paramUserData),
            contentType: 'application/json',
            success: function(res){
                alert("Login thành công. Xem token ở console")
                console.log(res);
                callAjaxApiLoginSuccess(res);
            },
            error: function(err){
                console.log(err.response);
                alert("Login không thành công")
            }
        })
    }
    function callAjaxApiSignup(paramUserData){
        "use strict";
        $.ajax({
            url: "http://localhost:8080/register",
            type: "POST",
            async: false,
            data: JSON.stringify(paramUserData),
            contentType: 'application/json',
            success: function(res){
                alert("Signup thành công. Xem console")
                console.log(res);
            },
            error: function(err){
                console.log(err.response);
                alert("Tạo tài khoản không thành công")
            }
        })
    }
    function callAjaxApiLoginSuccess(paramToken){
        "use strict";
        var settings = {
            "url": "http://localhost:8080/hello3",
            "method": "GET",
            "timeout": 0,
            "headers": {
                "Authorization": "Token " + paramToken,
            },
        };
        $.ajax(settings).done(function(response) {
            console.log("Dùng token để gọi api thành công. Response là: ")
            console.log(response);
        });
    }

})
</script>
</html>